<?
// INCLUDE UND TABELLEN-DEFINITIONEN
include('include/basesql.php');
include('include/common-functions.php');

// INCLUDE CURRENT-PROBLEMS
include('include/current-problems.php');

$tabs = array('cfg_graphic', 'cfg_network', 'cfg_input', 'client_auth', 'cfg_fluxbox_autostart', 'client_serials', 'cfg_comments', 'cfg_printers', 'cfg_sessions_citrix', 'cfg_sessions_storefront', 'cfg_sessions_rdesktop', 'cfg_modules', 'cfg_fluxbox_menuitem', 'cfg_screensaver', 'client_version');
$multi= array(	0,		 0,		0,		0,		1,		0,		1,		1,		1,		1,		1,		1,		1,		0,	0);
$data = array();

// get alx version info for 
$alxinfo = sqlfirst('SELECT * FROM client_version WHERE serial='.$id);
$alxos = $alxinfo['os'];
$alxutils = $alxinfo['utils'];
$alxarch = $alxinfo['arch'];

// get gfxdriver
$gfxinfo = sqlfirst('SELECT * FROM cfg_graphic WHERE serial='.$id);

if(isset($kill) and $kill==1)
{
	if($method=='DEACTIVATE') mysqli_query($DBCONN,'UPDATE client_serials SET enabled="0" WHERE serial='.$id);
	else mysqli_query($DBCONN,'UPDATE client_serials SET enabled="1" WHERE serial='.$id);

	echo '<body onload="window.setTimeout(\'window.close()\', 1750)">';
	echo '<table width=100% height=100% style="border:solid black 1px; background-color:#d5e5ff"><tr><td valign=middle align=center>';

	if($method=='DEACTIVATE') echo 'DEACTIVATED #'.$id;
	else echo 'ACTIVATED #'.$id;

	echo '</td></tr></table>';
	return true;
}

// FELD-DEFINITIONEN  (ARRAY=>DROPDOWN / HIDDEN / IGNORE / 1 / BOLD / PASSWORD / SHOW / SHOWTIME / MONITORID)
$drop = array();
$drop['cfg_graphic_module'] = sqlarr('SELECT value FROM values_graphic_module where enabled=1', '', 'value');
if($gfxinfo['module'] == 'intel')
{
	$drop['cfg_graphic_hdmi'] = array('disable', 'enable');
}
else
{
	$drop['cfg_graphic_hdmi'] = 'ignore';
}
$drop['resolution'] = sqlarr('SELECT value FROM values_graphic_resolution where enabled=1', '', 'value');
$drop['depth'] = sqlarr('SELECT value FROM values_graphic_depth where enabled=1', '', 'value');
//$drop['mouse'] = array('Auto', 'IMPS/2', 'PS/2');
//$drop['keyboard'] = array('PC105');
$drop['keymap'] = sqlarr('SELECT value FROM values_input_keymap where enabled=1', '', 'value');
$drop['cfg_network_module'] = sqlarr('SELECT value FROM values_network_module where enabled=1', '', 'value');
$drop['networking'] = array('dhcp', 'static');
$drop['port'] = sqlarr('SELECT value FROM values_printers_port where enabled=1', '', 'value');
//for ($i=0; $i<999; $i++) { $drop['cfg_printers_'.$i.'_ip'] = 'ignore'; }
$drop['share'] = 'ignore';
$drop['location'] = sqlarr('SELECT location FROM client_locations where enabled=1', '', 'location');
$drop['id'] = 'hidden';
$drop['flg_modified'] = '1';
$drop['serial'] = 'ignore';
$drop['monitorid'] = 'ignore';
$drop['refresh_rate'] = sqlarr('SELECT value FROM values_graphic_refresh_rate where enabled=1', '', 'value');
$drop['hostname'] = 'bold';
$drop['session'] = 'bold';
$drop['mtime'] = 'showtime';
$drop['mac'] = 'show';
$drop['arch'] = 'show';
$drop['client_serials_serial'] = 'show';
$drop['password'] = 'password';
//$drop['shell'] = 'password';
$drop['client_auth_user'] = 'password';
$drop['root'] = 'password';
$drop['vnc'] = 'password';
$drop['samba'] = 'password';
$drop['station'] = 'password';
$drop['txt'] = 'txt';
$drop['screensaver'] = sqlarr('SELECT value FROM values_screensaver_screensaver where enabled=1', '', 'value');
//$drop['iface'] = array('eth0', 'wlan0');
$drop['client_version_os'] = 'show';
$drop['client_version_utils'] = 'show';
$drop['hwdetected'] = 'ignore';

// ACHTUNG!!! wlan_-Felder heißen eigentlich wireless_
$drop['wireless_mode'] = sqlarr('SELECT value FROM values_network_wireless_mode where enabled=1', '', 'value');
$drop['wireless_auth_mode'] = sqlarr('SELECT value FROM values_network_wireless_auth_mode where enabled=1', '', 'value');
$drop['wireless_bitrate'] = sqlarr('SELECT value FROM values_network_wireless_bitrate where enabled=1', '', 'value');
$drop['wireless_key_length'] = sqlarr('SELECT value FROM values_network_wireless_key_length where enabled=1', '', 'value');
$drop['wireless_channel'] = sqlarr('SELECT value FROM values_network_wireless_channel where enabled=1', '', 'value');
$drop['wireless_frequency'] = sqlarr('SELECT value FROM values_network_wireless_frequency where enabled=1', '', 'value');
$drop['wireless_key'] = 'password';
$drop['wireless_key_ascii'] = 'password';

// get current citrix apps
$citrix_apps = sqlarr('SELECT session FROM values_citrix_session where enabled=1', '', 'session');
// add an empty value add the first position of the array as session-default
array_unshift($citrix_apps, "");
// hackish, fix me
for ($i=0; $i<999; $i++) { $drop['cfg_sessions_citrix_'.$i.'_session'] = $citrix_apps; }

// get current storefront apps
$storefront_apps = sqlarr('SELECT session FROM values_storefront_session where enabled=1', '', 'session');
// add an empty value add the first position of the array as session-default
array_unshift($storefront_apps, "");
// hackish, fix me
for ($i=0; $i<999; $i++) { $drop['cfg_sessions_storefront_'.$i.'_session'] = $storefront_apps; }

$drop['enabled'] = 'ignore';
$drop['filename'] = 'ignore';
$drop['autostart'] = array('0','1');

// GGF. NEUEN DATENSATZ EINFÜGEN
if(isset($_POST['do_add']))
{
	list($bla,$what) = explode(' ',$_POST['do_add']);
	if($what=='COMMENT')		sqladd('cfg_comments', array('serial'=>$id));
	else if($what=='PRINTER')	sqladd('cfg_printers', array('serial'=>$id));
	else if($what=='MODULE')	sqladd('cfg_modules', array('serial'=>$id));
	else if($what=='SESSION-CITRIX')	sqladd('cfg_sessions_citrix', array('domain'=>$citrix_domain_name, 'serverlist'=>$citrix_serverlist, 'serial'=>$id));
	else if($what=='SESSION-STOREFRONT')	sqladd('cfg_sessions_storefront', array('domain'=>$storefront_domain_name, 'store'=>$storefront_store, 'serial'=>$id));
	else if($what=='SESSION-RDP')	sqladd('cfg_sessions_rdesktop', array('domain'=>$rdesktop_domain_name, 'server'=>$rdesktop_server, 'serial'=>$id));
	else if($what=='MENUITEM')	sqladd('cfg_fluxbox_menuitem', array('serial'=>$id));
	else if($what=='AUTOSTART')	sqladd('cfg_fluxbox_autostart', array('serial'=>$id));
}


// GGF. SPEICHERN
if(isset($_POST['do_upl']))
{
	function postarr($prefix)
	{
		$prefix.='_';
		$prelen = strlen($prefix);

		$arr = array();
		foreach($_POST as $k=>$v)
		{
			if((substr($k,0,$prelen)==$prefix) && ($v!='KEEPPASS'))
				$arr[substr($k,$prelen)] = stripslashes($v);
		}

		return $arr;
	}

	foreach($tabs as $k=>$t)
	{
		if(!$multi[$k])	mysqli_query($DBCONN,'UPDATE '.$t.' SET '.updatestr(postarr($t)).' WHERE serial='.$id);
		else
		{
			$i=0;
			while(isset($_POST[$t.'_'.$i.'_id']))
			{
				if(isset($_POST[$t.'_'.$i.'_delete']))
					mysqli_query($DBCONN,'DELETE FROM '.$t.' WHERE serial='.$id.' AND id='.$_POST[$t.'_'.$i.'_id']);
				else
					mysqli_query($DBCONN,'UPDATE '.$t.' SET '.updatestr(postarr($t.'_'.$i)).' WHERE serial='.$id.' AND id='.$_POST[$t.'_'.$i.'_id']);
				$i++;
			}
		}
	}

	// reload site
	header("location: show.php?id=".$id);
}

// EINLESEN DER DATEN AUS SQL-TABELLEN
foreach($tabs as $k=>$t)
{
	if($multi[$k])	$data[$t] = sqlarr('SELECT * FROM '.$t.' WHERE serial='.$id);
	else		$data[$t] = sqlfirst('SELECT * FROM '.$t.' WHERE serial='.$id);
}

// ANZEIGEN - KLAPPFUNKTIONEN
$absnames = array();

function openabs($heading, $helpfile='')
{
	global $absnames;
	$absnames[] = $heading;

	// <AufZuLink> <Bild/> <Heading/> </AufZuLink><BR/> <Absatz>

	if( isset($_SESSION['openclose'][$heading]) )
	{
		echo '<a href="JavaScript:openclose(\''.$heading.'\',1);"><img border="0" src="pics/minus.gif" title="CLOSE" id="sch_bild_'.$heading.'"> <b>['.$heading.']</b></a>';
		if($helpfile!='')	echo ' <a href="JavaScript:showhelp(\''.$helpfile.'\')" title="HELP">[?]</a>';
		echo '<br><div id="sch_absatz_'.$heading.'" style="top:0px; visibility:visible">';
	}
	else
	{
		echo '<a href="JavaScript:openclose(\''.$heading.'\',1);"><img border="0" src="pics/plus.gif" title="OPEN" id="sch_bild_'.$heading.'"> <b>['.$heading.']</b></a>';
		if($helpfile!='')	echo ' <a href="JavaScript:showhelp(\''.$helpfile.'\')" title="HELP">[?]</a>';
		echo '<br><div id="sch_absatz_'.$heading.'" style="position:absolute; top:0px; visibility:hidden">';
	}
}

function closeabs()
{
	// </Absatz> <BR/>
	echo '</div><br>';
}

// ANZEIGEN

function parsearr($name, $arr, $del=false, $wireless=false)
{
	global $drop;
	global $id;
	global $alxos;

	$parts = explode('_',$name); $helpfile='help.php?page='.$parts[1];
	openabs($name, $helpfile);
	echo '<table class="keytab">';

	foreach($arr as $k=>$v)
	{
		if( (substr($k,0,9)=='wireless_') xor $wireless )	Continue;

		if(isset($drop[$name.'_'.$k])) $d = $drop[$name.'_'.$k];
		else $d=null;
		if(isset($drop[$k])) if($d==null) $d = $drop[$k];
		else $d=null;
		$k = str_replace('wireless_', '', $k);
		$k2 = $k;

		# tell something about vesa
//		if ($v == 'vesa') echo '<br><font color="#FF0000">Warning: "vesa" graphic module doesn\'t support any resolutions higher than 1024x786x16@60hz!</font><br>';

		if(is_array($d))
		{
			echo '<tr><td class="key">'.$k2.'</td><td>= <select style="width:144px" name="'.$name.'_'.$k.'">';
			foreach($d as $di) if($v==$di) echo '<option selected>'.$di; else echo '<option>'.$di;
			echo '</select></td></tr>';
		}
		else if($d=='hidden') 			echo '<tr><td colspan=2><input type=hidden name="'.$name.'_'.$k.'" value="'.$v.'"></td></tr>';
		else if($d=='1')			echo '<tr><td colspan=2><input type=hidden name="'.$name.'_'.$k.'" value="1"></td></tr>';
		else if($d=='monitorid')		echo '<tr><td class="key">'.$k2.'</td><td>= <input type=button style="width:24px" onclick="window.open(\'monitor.php?id='.$id.'\', \'MonitorWin\', \'width=350,height=200\')" value="..."></td>';
		else if($d=='bold')			echo '<tr><td class="key">'.$k2.'</td><td>= <input style="width:144px;font-weight:bold" name="'.$name.'_'.$k.'" value="'.$v.'"></td></tr>';
		else if($d=='filename')			echo '<tr><td class="key">filename</td><td>= <input style="width:144px;font-weight:bold" name="'.$name.'_'.$k.'" value="'.$v.'"></td></tr>';
		else if($d=='show')			echo '<tr><td class="key">'.$k2.'</td><td>= <b>'.$v.'</b></td></tr>';
		else if($d=='showtime')			echo '<tr><td class="key">'.$k2.'</td><td>= <b>'.date('d.m.y - H:i:s', $v).'</b></td></tr>';
		else if($d=='password' && $v=='')	echo '<tr><td class="key">'.$k2.'</td><td>= <input type=password style="width:144px" name="'.$name.'_'.$k.'" value=""></td></tr>';
		else if($d=='password')			echo '<tr><td class="key">'.$k2.'</td><td>= <input type=password style="width:144px" name="'.$name.'_'.$k.'" value="KEEPPASS"></td></tr>';
		else if($d=='txt') 			echo '<tr><td colspan=2><textarea style="width:240px; background-color:#d5e5ff" rows=6 name="'.$name.'_'.$k.'">'.$v.'</textarea></td></tr>';
		else if($d!='ignore')			echo '<tr><td class="key">'.$k2.'</td><td>= <input style="width:144px" name="'.$name.'_'.$k.'" value="'.$v.'"></td></tr>';
	}

	if($del)	echo '<tr><td class="key">delete</td><td>=<input type=checkbox name="'.$name.'_delete" value="1"></td></tr>';
	echo '</table>';
	closeabs();

	if($name=='cfg_network' && !$wireless)	parsearr($name.'_wireless', $arr, $del, true);
}

function parsearrs($name, $arr)
{
	foreach($arr as $k=>$a)
		parsearr($name.'_'.$k, $a, true);
}

?><head>
<title>ALX Config</title>
<style>
	body,table { font-family:Tahoma; font-size:10pt }
	a { color:#000000; text-decoration:none; }
	.key { width:85px }
	.keytab, input, textarea, select, option { font-size:8pt; font-family:Tahoma }
	.but { font-size:10pt; font-family:Tahoma; height:23px }
</style>
<script type="text/javascript" src="js/jquery-1.2.6.min.js"></script>
<script language="JavaScript" src="openclose_ajax.js"></script>
<script language="JavaScript">

	// opens an url and shows retval in a javascript-alert on current site
	function urlopen(url,typ) {
		var $url = url.split("?");
		$.ajax({type:""+typ+"",url:$url[0],data:$url[1],cache:false,success:function(data){ alert(data); }});
	}

	function openclose(nummer, act)
	{
		var bild = document.images['sch_bild_'+nummer];
		var absatz = document.all['sch_absatz_'+nummer].style;
		var senden = false;

		if(bild.title == 'OPEN')
		{
			if(act<=1)
			{
				absatz.visibility = 'visible';
				absatz.position = '';
				bild.title = 'CLOSE';
				bild.src = 'pics/minus.gif';
				senden = true;
				act = 0;
			}
		}
		else
		{
			if(act>=1)
			{
				absatz.visibility = 'hidden';
				absatz.position = 'absolute';
				bild.title = 'OPEN';
				bild.src = 'pics/plus.gif';
				senden = true;
				act = 2;
			}
		}
		if(senden)	sendopenclose(nummer,act);
	}

	function showhelp(name)
	{ window.open(name, 'HelpWin', 'width=620,height=500,scrollbars=yes'); }

</script>
</head>

<body><?

echo '<form action="show.php" method="post" onreset="return confirm(\'UNDO CHANGES?\')">';
echo '<input type=hidden name="do_upl" value="1">';
echo '<input type=hidden name="id" value="'.$id.'">';

// ANZEIGEN => NON-MULTI TABELLEN
echo '<table><tr><td valign=top width="300">';

	echo '<b style="font-size:6pt">';
	echo '<a href="JavaScript:opencloseall(0);" title="OPEN ALL"><img src="pics/plus.gif" border="0"> OPEN...</a> ';
	echo '<a href="JavaScript:opencloseall(2);" title="CLOSE ALL"><img src="pics/minus.gif" border="0"> CLOSE...</a> ALL';
	echo '</b><br><br>';

	foreach($tabs as $k=>$t)	if(!$multi[$k])		parsearr($t, $data[$t]);

// ANZEIGEN => MULTI TABELLEN
echo '</td><td valign=top width="300">';

	foreach($tabs as $k=>$t)	if($multi[$k])		parsearrs($t, $data[$t]);

	echo '<script language="JavaScript">';
	echo 'function opencloseall(act) { ';

	foreach($absnames as $absname)
		echo 'openclose("'.$absname.'", act); ';

	echo '}</script>';

// ANZEIGEN => NAVI
echo '</td><td valign=top>';

	// STATUS BESTIMMEN (ON/OFF)
	$conn = sqlfirst('SELECT * FROM state_connected WHERE serial='.$id);
	$state = 'Off';
	if(count($conn)>0)
	{
		$ping_retval = ping_host($conn['ip'],$mcore_port,$ping_timeout);
		if($ping_retval==0)
		{
			$state = 'On';
		}
	}

	echo '<img src="pics/logo2.jpg"><br><br>';

	echo '<input class="but" type=submit value="SAVE" style="width:150px"><br><br>';

	echo '<input class="but" type=submit name="do_add" value="ADD COMMENT" style="width:150px"><br>';
	echo '<input class="but" type=submit name="do_add" value="ADD PRINTER" style="width:150px"><br>';
	echo '<input class="but" type=submit name="do_add" value="ADD SESSION-CITRIX" style="width:150px"><br>';
	echo '<input class="but" type=submit name="do_add" value="ADD SESSION-STOREFRONT" style="width:150px"><br>';
	echo '<input class="but" type=submit name="do_add" value="ADD SESSION-RDP" style="width:150px"><br>';
	echo '<input class="but" type=submit name="do_add" value="ADD MODULE" style="width:150px"><br>';
	echo '<input class="but" type=submit name="do_add" value="ADD MENUITEM" style="width:150px"><br>';
	echo '<input class="but" type=submit name="do_add" value="ADD AUTOSTART" style="width:150px"><br>';
	echo '<br>';

	$clientstatus = sqlfirst('SELECT * FROM client_serials WHERE serial='.$id);
	if($clientstatus['enabled']>0) $KILLCAP='DEACTIVATE'; else $KILLCAP='ACTIVATE';
	echo '<input class="but" type=button value="'.$KILLCAP.'" style="width:150px" onclick="if(confirm(\''.$KILLCAP.' CLIENT #'.$id.' ?\')) { window.open(\'show.php?id='.$id.'&kill=1&method='.$KILLCAP.'\', \'DeactWin\', \'width=200,height=100\'); location.href=\'index.php\'; }"><br>';
	echo '<input class="but" type=button value="IMPORT FROM..." style="width:150px" onclick="location.href=\'import.php?id='.$id.'\'"><br>';
	echo '<input class="but" type=reset value="UNDO CHANGES" style="width:150px"><br><br>';

	$davor  = sqlfirst('SELECT mac FROM client_serials WHERE serial='.($id-1),'mac')!=null; if($davor) $disdavor=''; else $disdavor = 'disabled=1';
	$danach = sqlfirst('SELECT mac FROM client_serials WHERE serial='.($id+1),'mac')!=null; if($danach) $disdanach=''; else $disdanach = 'disabled=1';

	echo '<input class="but" type=button '.$disdavor.' value="<" style="width:30px" onclick="location.href=\'show.php?id='.($id-1).'\'">';
	echo '<input class="but" type=button value="REFRESH" style="width:90px" onclick="location.href=\'show.php?id='.$id.'\'">';
	echo '<input class="but" type=button '.$disdanach.' value=">" style="width:30px" onclick="location.href=\'show.php?id='.($id+1).'\'">';
	echo '<br><input class="but" type=button value="INDEX" style="width:150px; font-weight:bold" onclick="location.href=\'index.php\'"><br><br>';

	echo '<br>';
	echo '<div style="border:solid black 1px; padding:5px; background-color:#d5e5ff"><b>';
	if($id<0)	echo '<b>DEACTIVATED!</b><br><br>';
	echo '<u>Serial:</u>&nbsp;&nbsp;#'.$id.'<br>';
	echo '<u>Stand:</u>&nbsp;&nbsp;'.date('H:i:s').'<br>';
	echo '<u>Status:</u> <img src="pics/'.strtolower($state).'line.gif" align=top> '.$state.'line<br>';
	if($state=='On')
	{
		echo '<u>IP:</u> '.$conn['ip'].'<br>';
		if($conn['netboot'] == 1) echo '<u>Boot:</u> Netboot (PXE)<br>';
		else echo '<u>Boot:</u> Local Disk<br>';
		echo '<br>';
		echo '<u>OS:</u> '.$alxos.'<br>';
		echo '<u>Utils:</u> '.$alxutils.'<br>';
		echo '<u>Arch:</u> '.$alxarch.'<br>';
	}

	echo '</b></div>';

	if($state=='On')
	{
		echo '<input class="but" type=button value="REBOOT" style="width:150px" onclick="if(confirm(\'REBOOT CLIENT #'.$id.' ?\')) window.open(\'reboot.php?client='.$id.'&ip='.$conn['ip'].'&op=reboot\', \'ShutdownWin\', \'width=200,height=100\')"><br>';
		echo '<input class="but" type=button value="SHUTDOWN" style="width:150px" onclick="if(confirm(\'SHUTDOWN CLIENT #'.$id.' ?\')) window.open(\'reboot.php?client='.$id.'&ip='.$conn['ip'].'&op=shutdown\', \'ShutdownWin\', \'width=200,height=100\')"><br>';
		echo '<br>';
		echo '<div style="border:solid black 1px; padding:5px; background-color:#d5e5ff" align="center"><b>';
		echo 'Remote Shadow:</b></div>';
		echo '<input class="but" type=button value="VNC" style="width:75px" onclick="window.open(\'vncviewer.php?ip='.$conn['ip'].'\', \'VncViewer\', \'width=200,height=100\')">';
		echo '<input class="but" type=button value="SSH" style="width:75px" onclick="window.open(\'mindterm.php?ip='.$conn['ip'].'\', \'MindTerm\', \'width=200,height=100\')">';
	}
	else
		echo '<input class="but" type=button value="WAKE ON LAN" style="width:150px" onclick="if(confirm(\'WAKE CLIENT #'.$id.' ?\')) window.open(\'wake_on_lan.php?mac='.$data['client_serials']['mac'].'\', \'WakeWin\', \'width=200,height=100\')"><br>';

	// print version info
	$version = file_get_contents('./VERSION', FILE_USE_INCLUDE_PATH);
	echo '<br><br><font size="1">v'.$version.'</font>';

echo '</td></tr></table>';
echo '</form>';
?>
