<?

// Verbinden
include('dbconn.php');

function globaling()
{
	foreach ($_REQUEST as $key => $val)
	{
		global ${$key};
		${$key} = $val;
	}
}

globaling();

// Codiert die Anführungszeichen in einem String, sodass man ihn
// in einem SQL-Aufruf einbinden kann
function redir($str)
{
	$slash = "\\";
	return str_replace("'", $slash."'", str_replace($slash, $slash.$slash, $str));
}

function updatestr($arr)
{
	$res = '';
	foreach($arr as $k=>$v)
	{ if($res!='') $res.=','; $res.=$k.'=\''.redir($v).'\''; }
	return $res;
}

// Fügt der Tabelle $db einen neuen Datensatz mit den Werten des asso. Arrays $vals hinzu
function sqladd($db, $vals)
{
	global $DBCONN;

	$q = "INSERT INTO $db (";
	$i = 0; foreach($vals as $k=>$v) { if($i>0) { $q.=','; } $q .= redir($k); $i++; }
	$q .= ") VALUES (";
	$i = 0; foreach($vals as $k=>$v) { if($i>0) { $q.=','; } $q .= "'".redir($v)."'"; $i++; }
	$q .= ');';

	$result = mysqli_query($DBCONN, $q) or die("Anfrage fehlgeschlagen: " . mysqli_error($DBCONN));
}

// Führt eine Callbackfunktion für alle Elemente eines Arrays aus
function arrforeach(&$arr, $func, $params)
{
	foreach($arr as $k=>$v)
	{ $func($arr[$k], $params); }
}

// Holt ein array mit den Results einer MySQL-Abfrage
function sqlarr($query, $arrkey='', $arrval='')
{
	global $DBCONN;
	$arr = array();

	$result = mysqli_query($DBCONN, $query) or die("Anfrage fehlgeschlagen: " . mysqli_error($DBCONN));
	while ($line = mysqli_fetch_array($result, MYSQLI_ASSOC))
	{
		if($arrval=='')
		{
			if($arrkey=='') $arr[] = $line;
			else		$arr[$line[$arrkey]] = $line;
		}
		else
		{
			if($arrkey=='') $arr[] = $line[$arrval];
			else		$arr[$line[$arrkey]] = $line[$arrval];
		}
	}

	return $arr;
}

// Kopplung zw. arrforeach(sqlarr(...))
function sqlforeach($query, $func, $params)
{
	$myarr = sqlarr($query);
	arrforeach($myarr, $func, $params);
}

// ...
function sqlfirst($query, $prop='')
{
	global $DBCONN;

	$result = mysqli_query($DBCONN, $query) or die("Anfrage fehlgeschlagen: " . mysqli_error($DBCONN));
	if($line = mysqli_fetch_array($result, MYSQLI_ASSOC)) $res = $line;
	else $res = array();

	if($prop!='') $res = $res[$prop];
	return $res;
}

// ...
function sqlcount($what)
{
	$res = sqlfirst('SELECT count(*) c FROM '.$what);
	return $res['c'];
}

function ping_host($host, $port, $timeout)
{
	$retval = 244;

	$fp = @fsockopen($host, $port, $errCode, $errStr, $timeout);
	//echo "Ping $host:$port ==> ";
	if ($fp) {
		//echo 'SUCCESS';
		fclose($fp);
		$retval = 0;
	} else {
		//echo "ERROR: $errCode - $errStr";
		$retval = 1;
	}
	//echo PHP_EOL;

	return $retval;
}

?>
